]> git.sesse.net Git - backup.sh/blob - backup.sh
report.sh is no longer in use, so remove it.
[backup.sh] / backup.sh
1 #!/bin/bash
2 # backup.sh
3
4 # Backup up Unix-like computers
5
6 # itk@samfundet.no
7 #
8 # This script was first checked into RCS in 2000, and has since backed up a few
9 # servers almost every day, whenever not broken.
10
11 # It's a bit peculiar, but quite effective. The following is worth keeping in
12 # mind when hacking:
13 #
14 # KISS. And by that I mean really simple. Only regular Unix commands, please
15 # (but GNU extensions are used and moreutils has to be installed).
16 #
17 # Because of the way we run this script from cron, informational logging goes
18 # to stderr and warnings and errors to stdout. This way, we get mail whenever
19 # stuff fails, and other output is redirected to the log file.
20
21 # The script is halfway Norwegian and halfway English. Newer modifications are
22 # in English, we should probably stick to that.
23
24 # The computer to backup.
25 computer=$1
26
27 # Configuration
28 LOCKFILE=/home/backup/backuprun.lockfile.$computer
29 confdir=/home/backup/conf/              # Configuration files
30 storagedir=/backup                      # Where we keep backups
31 maksantallfulle=3                       # Number of full backups
32 dagermellomfulle=30                     # Days between full backups
33 dagermellomfulleforfast=32              # Days between full backups for machines with fixed
34                                         # full-backup date (in case the fixed day gets missed)
35 DAY_OF_MONTH=`date "+%d" | sed s/^0//`  # from 1 to 31
36 DATE=`date "+%Y%m%d%H%M"`               #format: touch
37 DATEs=`date "+%Y-%m-%d %H:%M"`          #format: tar
38
39 # Exclude-pattern
40 exclude=$confdir/exclude
41 [ ! -f $exclude ] && printf "tmp\ncore\n" > $exclude
42
43 if [ -z "$computer" ]; then
44         echo "Usage: $0 COMPUTER"
45         exit 1
46 fi
47
48 # Die more or less gracefully (at least notify user)
49 die() {
50         echo `date`": Something nasty happened. Ending, and not deleting lockfile $LOCKFILE."
51         exit 1
52 }
53
54 # Trap C-c and kill
55 trap die SIGINT SIGTERM
56
57 # Don't start if we're already running
58 if [ -e $LOCKFILE ]; then
59         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting."
60         echo `date`": $LOCKFILE exists for pid `cat $LOCKFILE`, exiting." >&2
61         exit 1
62 fi;
63 touch $LOCKFILE
64 echo $$ > $LOCKFILE
65
66 echo `date`": Backup run starting" >&2
67
68 umask 027
69
70
71 #selve backupen
72 # krever at noen variabler er satt
73 # krever at vi er i rett katalog
74 backup()
75 {
76
77  echo -n `date` >&2
78  printf " $computer: $computer:$filesystem $backuplevel backup\n" >&2
79
80  SNARFILE="${storagedir}/${computer}/${sfilesystem}/.incremental.snar"
81  incrementalsnar="/root/.backup/${sfilesystem}.snar"
82  if [ "$backuplevel" = "daglig" ]
83  then
84    # If incremental backup, we need to copy the incremental status to $computer.
85    # If it does not exist, whine a bit and then run date-based instead.
86    if [ -s "$SNARFILE" ]; then
87      if ! scp $SNARFILE root@$computer:$incrementalsnar; then
88        echo `date`" $computer: Could not copy .incremental.snar to $computer"
89        die
90      fi
91      lastcmd="--listed-incremental=$incrementalsnar --no-check-device"
92    else
93      echo `date`" $computer: Missing incremental.snar for $filesystem, doing date-based backup instead until next full backup" >&2
94      incrementalsnar=""
95      lastd=`cat ../.date`
96      lastcmd="--newer='$lastd'"
97    fi
98  else
99     lastcmd="--listed-incremental=$incrementalsnar"
100  fi
101
102  # expand the exclude-path for use with tar
103  exf=`ssh root@$computer "ls ~/.backup/exclude"`
104
105  # We try to run tar on the remote computer
106  #    c create archive
107  #    C change to directory first
108  #    . where to start taring (see C)
109  #    $lastcmd only files newer than this
110  #    --one-file-system don't traverse file systems
111  #    --use-compress-program compress it using gzip or pigz
112  #    --exclude-from file to get exclusion pattern from
113  #    Pipe the stuff over ssh to ourselves, run pee to cat the contents to a
114  #    file and build a file list, respectivly.  
115  TARFILE=$DATE.tmp
116  TARCMD="ssh root@$computer \"nice -n 19 ionice -c3 tar --one-file-system --use-compress-program $compressor -cf - -C $filesystem . $lastcmd \
117         --exclude-from=$exf\" | pee \"cat > $TARFILE\" \"tar tzvf -\""
118  echo `date`" $computer: Running $TARCMD" >&2
119  eval $TARCMD > $DATE.idx
120
121  if [ $? -eq 0 ] && [ -s $TARFILE ]; then
122   # File is >0 in size and neither cat or tar tzvf failed; we assume it worked.
123
124   if ! scp root@$computer:$incrementalsnar $SNARFILE.tmp; then
125     echo `date`" $computer: Could not copy .incremental.snar from $computer"
126     die
127   fi
128
129   # Move tar file in place
130   mv $TARFILE $DATE.tgz
131   mv $SNARFILE.tmp $SNARFILE
132
133   # Update timestamp
134   echo $DATEs > ../.date && touch -t $DATE ../.date
135
136   # Make a sorted filelist as well
137   sort -k6 < $DATE.idx > $DATE.sdx
138
139   # Fix permissions
140   chmod 600 *tgz                      #only for us
141   chmod 644 *sdx *idx 2>/dev/null     #everyone can read
142
143   # Let the remote computer know that we ran a successful backup (for nagios)
144   ssh root@$computer touch $filesystem/.lastbackup
145
146  else
147   # Something wrong happened.
148   rm $TARFILE
149   echo `date`" $computer: $TARFILE empty. $backuplevel backup of $computer:$filesystem failed and deleted"
150   die
151  fi
152
153 }
154
155  # Check that the target filesystem is mounted (actually check that it's not
156  # the root filesystem)
157  if [ ! -d "$storagedir/$computer" ]; then
158         echo `date`" $computer: Target filesystem ($storagedir/$computer) does not exist. Aborting"
159         die
160  fi
161  rootfilesystem=`df -P /`
162  targetfilesystem=`df -P "$storagedir/$computer"`
163  if [ "$rootfilesystem" == "$targetfilesystem" ]; then
164         echo `date`" $computer: Target filesystem ($storagedir/$computer) was mounted on /. Aborting"
165         die
166  fi
167
168  echo `date`" $computer: Backing up $computer" >&2
169
170  # Try to SSH to the computer without entering a password.
171  if ! `ssh -n -o NumberOfPasswordPrompts=0 root@$computer /bin/true`; then
172   echo `date`" $computer: Could not use passwordless SSH."
173   die
174  fi
175
176  # Check if pigz is available
177  if ssh -n root@$computer "pigz -V 2>/dev/null"; then
178    compressor=pigz
179  else
180    echo `date`" $computer: pigz missing; falling back to gzip."
181    compressor=gzip
182  fi
183  
184  # Check dump bit in fstab
185  filesystems=`ssh -n root@$computer "cat /etc/fstab" \
186   | grep -v nfs \
187   | grep -v "^#" \
188   | grep -v "^$" \
189   | awk '{ if ( $(NF-1) != "0" ) print $2}' `
190
191  # Clean up our dir at this client
192  if ! ssh root@$computer "rm -r ~/.backup ; mkdir -m 700 ~/.backup"; then
193   echo `date`" $computer: Could not create backup staging area at $computer:~/.backup"
194   die
195  fi
196
197  # Try to copy $exclude to $computer
198  if ! scp $exclude root@$computer:~/.backup/exclude > /dev/null; then
199   echo `date`" $computer: Could not copy exclude.txt to $computer"
200   die
201  fi
202
203  # Try to copy preeexec and postexec if they exist
204  if [ -f $confdir/preexec.$computer ]; then
205    if ! scp $confdir/preexec.$computer  root@$computer:~/.backup/preexec >&2; then
206      echo `date`" $computer: Could not copy preexec.$computer to $computer:~/.backup/preexec"
207      die
208    fi
209  fi
210  if [ -f $confdir/postexec.$computer ]; then
211    if ! scp $confdir/postexec.$computer root@$computer:~/.backup/postexec >&2; then
212      echo `date`" $computer: Could not copy postexec.$computer to $computer:~/.backup/postexec"
213      die
214    fi
215  fi
216
217  # Try to run preexec if it exist
218  if ! ssh root@$computer "[ ! -f ~/.backup/preexec ] || /bin/bash -x ~/.backup/preexec" >&2; then
219         echo `date`" $computer: Could not run $computer:~/.backup/preexec"
220         die
221  fi
222
223
224  for filesystem in $filesystems
225  do
226   # Remove / and $ (for Windows) for path names
227   sfilesystem=`echo $filesystem | tr '\/\$' '__'`
228
229   # Prepare storage area
230   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/full 2>/dev/null
231   mkdir -m 755 -p $storagedir/$computer/$sfilesystem/daglig 2>/dev/null
232
233   # Default backuplevel
234   backuplevel=daglig
235
236   if [ ! -f $storagedir/$computer/$sfilesystem/.date ]
237   then
238    # Take the first full backup of this filesystem on this computer
239    backuplevel=full
240    echo $DATEs > $storagedir/$computer/$sfilesystem/.date
241   fi
242
243   # Check if we want a full backup
244   if [ -f $confdir/fastfullbackupdag.$computer.$sfilesystem ]; then
245     fullbackup_min_for_this_machine=$dagermellomfulleforfast
246     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer.$sfilesystem`" ]; then
247       backuplevel=full
248     fi
249   elif [ -f $confdir/fastfullbackupdag.$computer ]; then
250     fullbackup_min_for_this_machine=$dagermellomfulleforfast
251     if [ "$DAY_OF_MONTH" = "`cat $confdir/fastfullbackupdag.$computer`" ]; then
252       backuplevel=full
253     fi
254   else
255     fullbackup_min_for_this_machine=$dagermellomfulle 
256   fi
257
258   if [ -z "`find $storagedir/$computer/$sfilesystem/full/ -name \*tgz -mtime -$fullbackup_min_for_this_machine`" ]; then
259    backuplevel=full
260   fi
261
262   # We want to be here
263   cd $storagedir/$computer/$sfilesystem/$backuplevel || die
264
265   # Perform the actual backup
266   backup
267
268   # Check if this box has a custom number of full backups
269   if [ -f $confdir/maksfulle.$computer ] ; then
270     mf=$((`cat $confdir/maksfulle.$computer`+1))
271   else
272     mf=$(($maksantallfulle+1))
273   fi
274
275   # Delete old full backups
276   for full in `ls -1t $storagedir/$computer/$sfilesystem/full/*tgz | tail -n +$mf`
277   do
278    prefix=`echo $full | sed "s/\.[^.]*$//"`
279    echo `date`": $computer:$filesystem Deleting full backup $prefix" >&2
280    rm $prefix*
281   done
282
283   # Delete incremental backups older than the oldest full backup
284   oldf=`ls -t1 $storagedir/$computer/$sfilesystem/full/*tgz | tail -1`
285   find \
286      $storagedir/$computer/$sfilesystem/daglig \
287      -type f \
288      \! -newer $oldf \
289      -printf "`date`: $computer: Deleting old incremental backup: %p\n" \
290      -exec rm {} \; >&2
291  done
292
293  # Try to run postexec if it exist
294  if ! ssh root@$computer "[ ! -f ~/.backup/postexec ] || /bin/bash -x ~/.backup/postexec" >&2; then
295         echo `date`" $computer: Could not run $computer:~/.backup/postexec"
296         die
297  fi
298
299 # Remove lockfile
300 rm $LOCKFILE